#include <iostream>
using namespace std;

int main(){
    int N, Q,n;
    int u,v,m,a,b,l,r,x;
    cin>> N;
    for(int i = 0; i<N; i++){
        cin>>n;
    }
    for(int i = 0; i<N-1; i++){
        cin>>u>>v;
    }
    cin>>Q;
    for(int i = 0; i<Q; i++){
        cin>>m;
        if(m == 1){
            cin>>a>>b;
        }else{
            cin>>l>>r>>x;
        }
    }
}